diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index ec5bd7eb157..3f561d33cbf 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -452,20 +452,50 @@ static HRESULT joydev_enum_deviceA(DWORD dwDevType, DWORD dwFlags, LPDIDEVICEINS
   return S_FALSE;
 }
 
-static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsigned short index)
+/******************************************************************************
+  *     get_joystick_index : Get the joystick index from a given GUID
+  */
+static unsigned short get_joystick_index(REFGUID guid)
+{
+    GUID wine_joystick = DInput_Wine_Joystick_Base_GUID;
+    GUID dev_guid = *guid;
+
+    wine_joystick.Data3 = 0;
+    dev_guid.Data3 = 0;
+
+    /* for the standard joystick GUID use index 0 */
+    if (IsEqualGUID(&GUID_Joystick, guid)) return 0;
+
+    /* for the wine joystick GUIDs use the index stored in Data3 */
+    if (IsEqualGUID(&wine_joystick, &dev_guid)) return guid->Data3 - DInput_Wine_Joystick_Base_GUID.Data3;
+
+    return MAX_JOYDEV;
+}
+
+static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID guid, JoystickGenericImpl **out)
 {
-    struct JoyDev *joydev = &joydevs[index];
+    struct JoyDev *joydev;
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
-    JoystickImpl* newDevice;
     LPDIDATAFORMAT df = NULL;
-    int i, idx = 0;
+    JoystickImpl *newDevice;
+    int i, index, idx = 0;
     int default_axis_map[WINE_JOYSTICK_MAX_AXES + WINE_JOYSTICK_MAX_POVS*2];
+    HRESULT hr;
+
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
+
+    find_joydevs();
+
+    *out = NULL;
+    if ((index = get_joystick_index(guid)) >= MAX_JOYDEV || !have_joydevs || index >= have_joydevs)
+        return DIERR_DEVICENOTREG;
+    joydev = &joydevs[index];
 
     fill_joystick_dideviceinstanceW(&didi, dinput->dwVersion, index);
 
-    if (FAILED(direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, joydev->vendor_id,
-                joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
-        return NULL;
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, guid, joydev->vendor_id,
+                       joydev->product_id, index, &didi, dinput, (void **)&newDevice)))
+        return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->base.crit");
     newDevice->generic.unix_funcs = &unix_joystick_vtbl;
     newDevice->generic.unix_ptr = unix_joystick_from_impl(newDevice);
@@ -527,9 +557,10 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
     }
 
     /* do any user specified configuration */
-    if (setup_dinput_options(&newDevice->generic, default_axis_map) != DI_OK) goto failed;
+    if (FAILED(hr = setup_dinput_options(&newDevice->generic, default_axis_map) != DI_OK)) goto failed;
 
     /* Create copy of default data format */
+    hr = DIERR_OUTOFMEMORY;
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto failed;
     memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
     if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto failed;
@@ -588,55 +619,15 @@ static JoystickImpl *alloc_device(REFGUID rguid, IDirectInputImpl *dinput, unsig
     if (newDevice->joydev->has_ff)
         newDevice->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
 
-    return newDevice;
+    *out = &newDevice->generic;
+    return DI_OK;
 
 failed:
     if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
     HeapFree(GetProcessHeap(), 0, df);
     HeapFree(GetProcessHeap(), 0, newDevice->generic.axis_map);
     HeapFree(GetProcessHeap(), 0, newDevice);
-    return NULL;
-}
-
-/******************************************************************************
-  *     get_joystick_index : Get the joystick index from a given GUID
-  */
-static unsigned short get_joystick_index(REFGUID guid)
-{
-    GUID wine_joystick = DInput_Wine_Joystick_Base_GUID;
-    GUID dev_guid = *guid;
-
-    wine_joystick.Data3 = 0;
-    dev_guid.Data3 = 0;
-
-    /* for the standard joystick GUID use index 0 */
-    if(IsEqualGUID(&GUID_Joystick,guid)) return 0;
-
-    /* for the wine joystick GUIDs use the index stored in Data3 */
-    if(IsEqualGUID(&wine_joystick, &dev_guid)) return guid->Data3 - DInput_Wine_Joystick_Base_GUID.Data3;
-
-    return MAX_JOYDEV;
-}
-
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
-{
-    unsigned short index;
-
-    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
-    find_joydevs();
-    *out = NULL;
-
-    if ((index = get_joystick_index(guid)) < MAX_JOYDEV &&
-        have_joydevs && index < have_joydevs)
-    {
-        JoystickImpl *This = alloc_device(guid, dinput, index);
-        TRACE("Created a Joystick device (%p)\n", This);
-        if (!This) return DIERR_OUTOFMEMORY;
-        *out = &This->generic.base;
-        return DI_OK;
-    }
-
-    return DIERR_DEVICENOTREG;
+    return hr;
 }
 
 
@@ -644,7 +635,8 @@ const struct dinput_device joystick_linuxinput_device = {
   "Wine Linux-input joystick driver",
   joydev_enum_deviceA,
   NULL,
-  joydev_create_device
+  NULL,
+  joydev_create_unix_joystick
 };
 
 /******************************************************************************
diff --git a/dlls/dinput/joystick_osx.c b/dlls/dinput/joystick_osx.c
index 19c2e2dddf4..cbd761ad935 100644
--- a/dlls/dinput/joystick_osx.c
+++ b/dlls/dinput/joystick_osx.c
@@ -1074,8 +1074,27 @@ static void fill_joystick_dideviceinstanceW(LPDIDEVICEINSTANCEW didi, IOHIDDevic
     didi->wUsage = 0;
 }
 
-static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
-                            JoystickImpl **pdev, unsigned short index)
+/******************************************************************************
+  *     get_joystick_index : Get the joystick index from a given GUID
+  */
+static unsigned short get_joystick_index(REFGUID guid)
+{
+    GUID wine_joystick = DInput_Wine_OsX_Joystick_GUID;
+    GUID dev_guid = *guid;
+
+    wine_joystick.Data3 = 0;
+    dev_guid.Data3 = 0;
+
+    /* for the standard joystick GUID use index 0 */
+    if (IsEqualGUID(&GUID_Joystick, guid)) return 0;
+
+    /* for the wine joystick GUIDs use the index stored in Data3 */
+    if (IsEqualGUID(&wine_joystick, &dev_guid)) return guid->Data3;
+
+    return 0xffff;
+}
+
+static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID guid, JoystickGenericImpl **out)
 {
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
     DWORD i;
@@ -1084,13 +1103,22 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
     char name[MAX_PATH];
     HRESULT hr;
     LPDIDATAFORMAT df = NULL;
+    unsigned short index;
     int idx = 0;
     int axis_map[8]; /* max axes */
     int slider_count = 0;
+    int joystick_devices_count;
     FFCAPABILITIES ffcaps;
     WORD vendor_id, product_id;
 
-    TRACE("%s %p %p %hu\n", debugstr_guid(rguid), dinput, pdev, index);
+    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
+
+    *out = NULL;
+
+    if ((joystick_devices_count = find_joystick_devices()) == 0) return DIERR_DEVICENOTREG;
+
+    if ((index = get_joystick_index(guid)) >= 0xffff || !joystick_devices_count || index >= joystick_devices_count)
+        return DIERR_DEVICENOTREG;
 
     device = get_device_ref(index);
     vendor_id = get_device_property_long(device, CFSTR(kIOHIDVendorIDKey));
@@ -1098,7 +1126,7 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
 
     fill_joystick_dideviceinstanceW(&didi, device, dinput->dwVersion, index, name);
 
-    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, rguid, vendor_id, product_id, index,
+    if (FAILED(hr = direct_input_device_alloc(sizeof(JoystickImpl), &JoystickWvt, guid, vendor_id, product_id, index,
                        &didi, dinput, (void **)&newDevice)))
         return hr;
     newDevice->generic.base.crit.DebugInfo->Spare[0] = (DWORD_PTR)(__FILE__ ": JoystickImpl*->generic.base.crit");
@@ -1243,8 +1271,7 @@ static HRESULT alloc_device(REFGUID rguid, IDirectInputImpl *dinput,
         _dump_DIDEVCAPS(&newDevice->generic.devcaps);
     }
 
-    *pdev = newDevice;
-
+    *out = &newDevice->generic;
     return DI_OK;
 
 FAILED:
@@ -1256,55 +1283,9 @@ FAILED:
     release_DataFormat(&newDevice->generic.base.data_format);
     HeapFree(GetProcessHeap(),0,newDevice->generic.name);
     HeapFree(GetProcessHeap(),0,newDevice);
-    *pdev = 0;
-
     return hr;
 }
 
-/******************************************************************************
-  *     get_joystick_index : Get the joystick index from a given GUID
-  */
-static unsigned short get_joystick_index(REFGUID guid)
-{
-    GUID wine_joystick = DInput_Wine_OsX_Joystick_GUID;
-    GUID dev_guid = *guid;
-
-    wine_joystick.Data3 = 0;
-    dev_guid.Data3 = 0;
-
-    /* for the standard joystick GUID use index 0 */
-    if(IsEqualGUID(&GUID_Joystick,guid)) return 0;
-
-    /* for the wine joystick GUIDs use the index stored in Data3 */
-    if(IsEqualGUID(&wine_joystick, &dev_guid)) return guid->Data3;
-
-    return 0xffff;
-}
-
-static HRESULT joydev_create_device(IDirectInputImpl *dinput, REFGUID guid, IDirectInputDeviceImpl **out)
-{
-    unsigned short index;
-    int joystick_devices_count;
-
-    TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
-    *out = NULL;
-
-    if ((joystick_devices_count = find_joystick_devices()) == 0)
-        return DIERR_DEVICENOTREG;
-
-    if ((index = get_joystick_index(guid)) < 0xffff &&
-        joystick_devices_count && index < joystick_devices_count)
-    {
-        JoystickImpl *This;
-        HRESULT hr = alloc_device(guid, dinput, &This, index);
-        if (!This) return hr;
-        *out = &This->generic.base;
-        return hr;
-    }
-
-    return DIERR_DEVICENOTREG;
-}
-
 static HRESULT CDECL unix_joystick_ff_set_autocenter(struct unix_joystick *ptr, DWORD value)
 {
     JoystickImpl *This = impl_from_unix_joystick(ptr);
@@ -1414,7 +1395,8 @@ const struct dinput_device joystick_osx_device = {
   "Wine OS X joystick driver",
   joydev_enum_deviceA,
   NULL,
-  joydev_create_device
+  NULL,
+  joydev_create_unix_joystick
 };
 
 static const IDirectInputDevice8WVtbl JoystickWvt =
diff --git a/dlls/dinput/joystick_private.h b/dlls/dinput/joystick_private.h
index e479ea6b480..87e91a21133 100644
--- a/dlls/dinput/joystick_private.h
+++ b/dlls/dinput/joystick_private.h
@@ -71,6 +71,8 @@ typedef struct JoystickGenericImpl
     struct list ff_effects;
 } JoystickGenericImpl;
 
+extern HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectInputImpl *dinput, REFGUID guid, REFIID iid, void **out) DECLSPEC_HIDDEN;
+
 LONG joystick_map_axis(ObjProps *props, int val) DECLSPEC_HIDDEN;
 HRESULT setup_dinput_options(JoystickGenericImpl *This, const int *default_axis_map) DECLSPEC_HIDDEN;
 
diff --git a/dlls/dinput/keyboard.c b/dlls/dinput/keyboard.c
index 79c57c50d28..b257f2b51c1 100644
--- a/dlls/dinput/keyboard.c
+++ b/dlls/dinput/keyboard.c
@@ -259,7 +259,8 @@ const struct dinput_device keyboard_device = {
   "Wine keyboard driver",
   NULL,
   keyboarddev_enum_deviceW,
-  keyboarddev_create_device
+  keyboarddev_create_device,
+  NULL
 };
 
 static HRESULT WINAPI SysKeyboardWImpl_GetDeviceState(LPDIRECTINPUTDEVICE8W iface, DWORD len, LPVOID ptr)
diff --git a/dlls/dinput/mouse.c b/dlls/dinput/mouse.c
index f81fe92cf22..c436bf5032a 100644
--- a/dlls/dinput/mouse.c
+++ b/dlls/dinput/mouse.c
@@ -217,7 +217,8 @@ const struct dinput_device mouse_device = {
     "Wine mouse driver",
     NULL,
     mousedev_enum_deviceW,
-    mousedev_create_device
+    mousedev_create_device,
+    NULL
 };
 
 /******************************************************************************
-- 
2.28.0

>From b5c3f702d9ab24dc829c7142980a8d1bd0fa0ac4 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?R=C3=A9mi=20Bernon?= <rbernon@codeweavers.com>
Date: Tue, 6 Oct 2020 02:00:13 +0200
Subject: [PATCH 23/39] dinput: Use the unix vtable for initialization.

---
 dlls/dinput/joystick.c            |   1 +
 dlls/dinput/joystick_linux.c      |  84 ++++++++++++---------
 dlls/dinput/joystick_linuxinput.c | 113 ++++++++++++++--------------
 dlls/dinput/joystick_osx.c        | 119 +++++++++++++++++-------------
 dlls/dinput/joystick_private.h    |   2 +
 5 files changed, 175 insertions(+), 144 deletions(-)

diff --git a/dlls/dinput/joystick.c b/dlls/dinput/joystick.c
index 94525875ca5..8cf7ff05a0b 100644
--- a/dlls/dinput/joystick.c
+++ b/dlls/dinput/joystick.c
@@ -1180,6 +1180,7 @@ HRESULT dinput_create_unix_joystick(const struct dinput_device *device, IDirectI
     HRESULT hr;
 
     if (FAILED(hr = device->create_unix_joystick(dinput, guid, &This))) return hr;
+    if (FAILED(hr = This->unix_funcs->init(This->unix_ptr))) goto done;
     if (FAILED(hr = IDirectInputDevice8_QueryInterface(IDirectInputDevice8W_from_impl(This), iid, out))) goto done;
 
     TRACE("created unix joystick %p\n", This);
diff --git a/dlls/dinput/joystick_linux.c b/dlls/dinput/joystick_linux.c
index ae75a3dbf20..873ee88c20c 100644
--- a/dlls/dinput/joystick_linux.c
+++ b/dlls/dinput/joystick_linux.c
@@ -138,8 +138,11 @@ static void CDECL unix_joystick_poll(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_acquire(struct unix_joystick *ptr);
 static HRESULT CDECL unix_joystick_unacquire(struct unix_joystick *ptr);
 
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
+    unix_joystick_init,
     unix_joystick_acquire,
     unix_joystick_unacquire,
     NULL,
@@ -471,10 +474,9 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
 {
     struct JoyDev *joydev;
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
-    LPDIDATAFORMAT df = NULL;
     JoystickImpl *newDevice;
     HRESULT hr;
-    DWORD i, index, idx = 0;
+    DWORD index;
 
     TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
 
@@ -496,33 +498,45 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
 
     newDevice->joydev = joydev;
     newDevice->joyfd = -1;
-    newDevice->generic.name = newDevice->joydev->name;
-    newDevice->generic.device_axis_count = newDevice->joydev->axis_count;
-    newDevice->generic.devcaps.dwButtons = newDevice->joydev->button_count;
 
-    if (newDevice->generic.devcaps.dwButtons > 128)
+    *out = &newDevice->generic;
+    return DI_OK;
+}
+
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    LPDIDATAFORMAT df = NULL;
+    HRESULT hr;
+    DWORD i, idx = 0;
+
+    This->generic.name = This->joydev->name;
+    This->generic.device_axis_count = This->joydev->axis_count;
+    This->generic.devcaps.dwButtons = This->joydev->button_count;
+
+    if (This->generic.devcaps.dwButtons > 128)
     {
-        WARN("Can't support %d buttons. Clamping down to 128\n", newDevice->generic.devcaps.dwButtons);
-        newDevice->generic.devcaps.dwButtons = 128;
+        WARN("Can't support %d buttons. Clamping down to 128\n", This->generic.devcaps.dwButtons);
+        This->generic.devcaps.dwButtons = 128;
     }
 
     /* setup_dinput_options may change these */
-    newDevice->generic.deadzone = 0;
+    This->generic.deadzone = 0;
 
     /* do any user specified configuration */
-    if (FAILED(hr = setup_dinput_options(&newDevice->generic, newDevice->joydev->dev_axes_map))) goto failed;
+    if (FAILED(hr = setup_dinput_options(&This->generic, This->joydev->dev_axes_map))) goto failed;
 
     /* Create copy of default data format */
     hr = DIERR_OUTOFMEMORY;
     if (!(df = HeapAlloc(GetProcessHeap(), 0, c_dfDIJoystick2.dwSize))) goto failed;
     memcpy(df, &c_dfDIJoystick2, c_dfDIJoystick2.dwSize);
 
-    df->dwNumObjs = newDevice->generic.devcaps.dwAxes + newDevice->generic.devcaps.dwPOVs + newDevice->generic.devcaps.dwButtons;
+    df->dwNumObjs = This->generic.devcaps.dwAxes + This->generic.devcaps.dwPOVs + This->generic.devcaps.dwButtons;
     if (!(df->rgodf = HeapAlloc(GetProcessHeap(), 0, df->dwNumObjs * df->dwObjSize))) goto failed;
 
-    for (i = 0; i < newDevice->generic.device_axis_count; i++)
+    for (i = 0; i < This->generic.device_axis_count; i++)
     {
-        int wine_obj = newDevice->generic.axis_map[i];
+        int wine_obj = This->generic.axis_map[i];
 
         if (wine_obj < 0) continue;
 
@@ -535,49 +549,47 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
             i++; /* POV takes 2 axes */
         }
     }
-    for (i = 0; i < newDevice->generic.devcaps.dwButtons; i++)
+    for (i = 0; i < This->generic.devcaps.dwButtons; i++)
     {
         memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[i + 12], df->dwObjSize);
         df->rgodf[idx  ].pguid = &GUID_Button;
         df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(i) | DIDFT_PSHBUTTON;
     }
-    newDevice->generic.base.data_format.wine_df = df;
+    This->generic.base.data_format.wine_df = df;
 
     /* initialize default properties */
     for (i = 0; i < c_dfDIJoystick2.dwNumObjs; i++) {
-        newDevice->generic.props[i].lDevMin = -32767;
-        newDevice->generic.props[i].lDevMax = +32767;
-        newDevice->generic.props[i].lMin = 0;
-        newDevice->generic.props[i].lMax = 0xffff;
-        newDevice->generic.props[i].lDeadZone = newDevice->generic.deadzone; /* % * 1000 */
-        newDevice->generic.props[i].lSaturation = 0;
+        This->generic.props[i].lDevMin = -32767;
+        This->generic.props[i].lDevMax = +32767;
+        This->generic.props[i].lMin = 0;
+        This->generic.props[i].lMax = 0xffff;
+        This->generic.props[i].lDeadZone = This->generic.deadzone; /* % * 1000 */
+        This->generic.props[i].lSaturation = 0;
     }
 
-    newDevice->generic.devcaps.dwSize = sizeof(newDevice->generic.devcaps);
-    newDevice->generic.devcaps.dwFlags = DIDC_ATTACHED;
-    newDevice->generic.devcaps.dwDevType = didi.dwDevType;
+    This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
+    This->generic.devcaps.dwFlags = DIDC_ATTACHED;
+    This->generic.devcaps.dwDevType = This->generic.base.info.dwDevType;
 
-    newDevice->generic.devcaps.dwFFSamplePeriod = 0;
-    newDevice->generic.devcaps.dwFFMinTimeResolution = 0;
-    newDevice->generic.devcaps.dwFirmwareRevision = 0;
-    newDevice->generic.devcaps.dwHardwareRevision = 0;
-    newDevice->generic.devcaps.dwFFDriverVersion = 0;
+    This->generic.devcaps.dwFFSamplePeriod = 0;
+    This->generic.devcaps.dwFFMinTimeResolution = 0;
+    This->generic.devcaps.dwFirmwareRevision = 0;
+    This->generic.devcaps.dwHardwareRevision = 0;
+    This->generic.devcaps.dwFFDriverVersion = 0;
 
     if (TRACE_ON(dinput)) {
-        for (i = 0; i < (newDevice->generic.device_axis_count); i++)
-            TRACE("axis_map[%d] = %d\n", i, newDevice->generic.axis_map[i]);
-        _dump_DIDEVCAPS(&newDevice->generic.devcaps);
+        for (i = 0; i < (This->generic.device_axis_count); i++)
+            TRACE("axis_map[%d] = %d\n", i, This->generic.axis_map[i]);
+        _dump_DIDEVCAPS(&This->generic.devcaps);
     }
 
-    *out = &newDevice->generic;
     return DI_OK;
 
 failed:
     if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
     HeapFree(GetProcessHeap(), 0, df);
-    release_DataFormat(&newDevice->generic.base.data_format);
-    HeapFree(GetProcessHeap(), 0, newDevice->generic.axis_map);
-    HeapFree(GetProcessHeap(), 0, newDevice);
+    release_DataFormat(&This->generic.base.data_format);
+    HeapFree(GetProcessHeap(), 0, This->generic.axis_map);
     return hr;
 }
 
diff --git a/dlls/dinput/joystick_linuxinput.c b/dlls/dinput/joystick_linuxinput.c
index 3f561d33cbf..5f0df95e3d0 100644
--- a/dlls/dinput/joystick_linuxinput.c
+++ b/dlls/dinput/joystick_linuxinput.c
@@ -169,8 +169,11 @@ static HRESULT CDECL unix_joystick_get_effect_info(struct unix_joystick *ptr, RE
 static HRESULT CDECL unix_joystick_create_effect(struct unix_joystick *ptr, REFGUID guid, const DIEFFECT *effect,
         struct list *entry, IDirectInputEffect **out);
 
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr);
+
 static const struct unix_joystick_vtbl unix_joystick_vtbl =
 {
+    unix_joystick_init,
     unix_joystick_acquire,
     unix_joystick_unacquire,
     unix_joystick_ff_set_autocenter,
@@ -476,11 +479,9 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
 {
     struct JoyDev *joydev;
     DIDEVICEINSTANCEW didi = {sizeof(didi)};
-    LPDIDATAFORMAT df = NULL;
     JoystickImpl *newDevice;
-    int i, index, idx = 0;
-    int default_axis_map[WINE_JOYSTICK_MAX_AXES + WINE_JOYSTICK_MAX_POVS*2];
     HRESULT hr;
+    int index;
 
     TRACE("%p %s %p\n", dinput, debugstr_guid(guid), out);
 
@@ -502,62 +503,69 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
 
     newDevice->joyfd       = -1;
     newDevice->joydev = joydev;
-    newDevice->generic.name        = newDevice->joydev->name;
-    list_init(&newDevice->generic.ff_effects);
+
+    *out = &newDevice->generic;
+    return DI_OK;
+}
+
+static HRESULT CDECL unix_joystick_init(struct unix_joystick *ptr)
+{
+    JoystickImpl *This = impl_from_unix_joystick(ptr);
+    LPDIDATAFORMAT df = NULL;
+    HRESULT hr;
+    int i, idx = 0, default_axis_map[WINE_JOYSTICK_MAX_AXES + WINE_JOYSTICK_MAX_POVS * 2];
+
+    This->generic.name = This->joydev->name;
+    list_init(&This->generic.ff_effects);
 #ifdef HAVE_STRUCT_FF_EFFECT_DIRECTION
-    newDevice->ff_state    = FF_STATUS_STOPPED;
+    This->ff_state = FF_STATUS_STOPPED;
 #endif
     /* There is no way in linux to query force feedback autocenter status.
        Instead, track it with ff_autocenter, and assume it's initially
        enabled. */
-    newDevice->ff_autocenter = 1;
-    newDevice->ff_gain = 0xFFFF;
-    newDevice->generic.ff_autocenter = DIPROPAUTOCENTER_ON;
-    newDevice->generic.ff_gain = 10000;
+    This->ff_autocenter = 1;
+    This->ff_gain = 0xFFFF;
+    This->generic.ff_autocenter = DIPROPAUTOCENTER_ON;
+    This->generic.ff_gain = 10000;
 
     /* Count number of available axes - supported Axis & POVs */
     for (i = 0; i < ABS_MAX; i++)
     {
-        if (idx < WINE_JOYSTICK_MAX_AXES &&
-            i < ABS_HAT0X &&
-            test_bit(newDevice->joydev->absbits, i))
+        if (idx < WINE_JOYSTICK_MAX_AXES && i < ABS_HAT0X && test_bit(This->joydev->absbits, i))
         {
-            newDevice->generic.device_axis_count++;
-            newDevice->dev_axes_to_di[i] = idx;
-            newDevice->generic.props[idx].lDevMin = newDevice->joydev->axes[i].minimum;
-            newDevice->generic.props[idx].lDevMax = newDevice->joydev->axes[i].maximum;
+            This->generic.device_axis_count++;
+            This->dev_axes_to_di[i] = idx;
+            This->generic.props[idx].lDevMin = This->joydev->axes[i].minimum;
+            This->generic.props[idx].lDevMax = This->joydev->axes[i].maximum;
             if (i >= 8 && i <= 10) /* If it's a wheel axis... */
                 default_axis_map[idx] = i - 8; /* ... remap to X/Y/Z */
             else
                 default_axis_map[idx] = i;
             idx++;
         }
-        else
-            newDevice->dev_axes_to_di[i] = -1;
+        else This->dev_axes_to_di[i] = -1;
     }
 
     for (i = 0; i < WINE_JOYSTICK_MAX_POVS; i++)
     {
-        if (test_bit(newDevice->joydev->absbits, ABS_HAT0X + i * 2) &&
-            test_bit(newDevice->joydev->absbits, ABS_HAT0Y + i * 2))
+        if (test_bit(This->joydev->absbits, ABS_HAT0X + i * 2) && test_bit(This->joydev->absbits, ABS_HAT0Y + i * 2))
         {
-            newDevice->generic.device_axis_count += 2;
-            newDevice->generic.props[idx  ].lDevMin = newDevice->joydev->axes[ABS_HAT0X + i * 2].minimum;
-            newDevice->generic.props[idx  ].lDevMax = newDevice->joydev->axes[ABS_HAT0X + i * 2].maximum;
-            newDevice->dev_axes_to_di[ABS_HAT0X + i * 2] = idx;
-            newDevice->generic.props[idx+1].lDevMin = newDevice->joydev->axes[ABS_HAT0Y + i * 2].minimum;
-            newDevice->generic.props[idx+1].lDevMax = newDevice->joydev->axes[ABS_HAT0Y + i * 2].maximum;
-            newDevice->dev_axes_to_di[ABS_HAT0Y + i * 2] = idx + 1;
+            This->generic.device_axis_count += 2;
+            This->generic.props[idx].lDevMin = This->joydev->axes[ABS_HAT0X + i * 2].minimum;
+            This->generic.props[idx].lDevMax = This->joydev->axes[ABS_HAT0X + i * 2].maximum;
+            This->dev_axes_to_di[ABS_HAT0X + i * 2] = idx;
+            This->generic.props[idx + 1].lDevMin = This->joydev->axes[ABS_HAT0Y + i * 2].minimum;
+            This->generic.props[idx + 1].lDevMax = This->joydev->axes[ABS_HAT0Y + i * 2].maximum;
+            This->dev_axes_to_di[ABS_HAT0Y + i * 2] = idx + 1;
 
             default_axis_map[idx] = default_axis_map[idx + 1] = WINE_JOYSTICK_MAX_AXES + i;
             idx += 2;
         }
-        else
-            newDevice->dev_axes_to_di[ABS_HAT0X + i * 2] = newDevice->dev_axes_to_di[ABS_HAT0Y + i * 2] = -1;
+        else This->dev_axes_to_di[ABS_HAT0X + i * 2] = This->dev_axes_to_di[ABS_HAT0Y + i * 2] = -1;
     }
 
     /* do any user specified configuration */
-    if (FAILED(hr = setup_dinput_options(&newDevice->generic, default_axis_map) != DI_OK)) goto failed;
+    if (FAILED(hr = setup_dinput_options(&This->generic, default_axis_map) != DI_OK)) goto failed;
 
     /* Create copy of default data format */
     hr = DIERR_OUTOFMEMORY;
@@ -569,9 +577,9 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
     /* Construct internal data format */
 
     /* Supported Axis & POVs */
-    for (i = 0, idx = 0; i < newDevice->generic.device_axis_count; i++)
+    for (i = 0, idx = 0; i < This->generic.device_axis_count; i++)
     {
-        int wine_obj = newDevice->generic.axis_map[i];
+        int wine_obj = This->generic.axis_map[i];
 
         if (wine_obj < 0) continue;
 
@@ -584,53 +592,48 @@ static HRESULT joydev_create_unix_joystick(IDirectInputImpl *dinput, REFGUID gui
             i++; /* POV takes 2 axes */
         }
 
-        newDevice->generic.props[idx].lMin        = 0;
-        newDevice->generic.props[idx].lMax        = 0xffff;
-        newDevice->generic.props[idx].lSaturation = 0;
-        newDevice->generic.props[idx].lDeadZone   = newDevice->generic.deadzone;
+        This->generic.props[idx].lMin = 0;
+        This->generic.props[idx].lMax = 0xffff;
+        This->generic.props[idx].lSaturation = 0;
+        This->generic.props[idx].lDeadZone = This->generic.deadzone;
 
         /* Linux supports force-feedback on X & Y axes only */
-        if (newDevice->joydev->has_ff && (i == 0 || i == 1))
-            df->rgodf[idx].dwFlags |= DIDOI_FFACTUATOR;
+        if (This->joydev->has_ff && (i == 0 || i == 1)) df->rgodf[idx].dwFlags |= DIDOI_FFACTUATOR;
 
         idx++;
     }
 
     /* Buttons can be anywhere, so check all */
-    for (i = 0; i < KEY_MAX && newDevice->generic.devcaps.dwButtons < WINE_JOYSTICK_MAX_BUTTONS; i++)
+    for (i = 0; i < KEY_MAX && This->generic.devcaps.dwButtons < WINE_JOYSTICK_MAX_BUTTONS; i++)
     {
-        if (!test_bit(newDevice->joydev->keybits, i)) continue;
+        if (!test_bit(This->joydev->keybits, i)) continue;
 
-        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[newDevice->generic.devcaps.dwButtons + 12], df->dwObjSize);
-        newDevice->buttons[i] = 0x80 | newDevice->generic.devcaps.dwButtons;
+        memcpy(&df->rgodf[idx], &c_dfDIJoystick2.rgodf[This->generic.devcaps.dwButtons + 12], df->dwObjSize);
+        This->buttons[i] = 0x80 | This->generic.devcaps.dwButtons;
         df->rgodf[idx  ].pguid = &GUID_Button;
-        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(newDevice->generic.devcaps.dwButtons++) | DIDFT_PSHBUTTON;
+        df->rgodf[idx++].dwType = DIDFT_MAKEINSTANCE(This->generic.devcaps.dwButtons++) | DIDFT_PSHBUTTON;
     }
     df->dwNumObjs = idx;
-    newDevice->generic.base.data_format.wine_df = df;
+    This->generic.base.data_format.wine_df = df;
 
-    fake_current_js_state(newDevice);
+    fake_current_js_state(This);
 
     /* Fill the caps */
-    newDevice->generic.devcaps.dwSize = sizeof(newDevice->generic.devcaps);
-    newDevice->generic.devcaps.dwFlags = DIDC_ATTACHED;
-    newDevice->generic.devcaps.dwDevType = didi.dwDevType;
+    This->generic.devcaps.dwSize = sizeof(This->generic.devcaps);
+    This->generic.devcaps.dwFlags = DIDC_ATTACHED;
+    This->generic.devcaps.dwDevType = This->generic.base.info.dwDevType;
 
-    if (newDevice->joydev->has_ff)
-        newDevice->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
+    if (This->joydev->has_ff) This->generic.devcaps.dwFlags |= DIDC_FORCEFEEDBACK;
 
-    *out = &newDevice->generic;
     return DI_OK;
 
 failed:
     if (df) HeapFree(GetProcessHeap(), 0, df->rgodf);
     HeapFree(GetProcessHeap(), 0, df);
-    HeapFree(GetProcessHeap(), 0, newDevice->generic.axis_map);
-    HeapFree(GetProcessHeap(), 0, newDevice);
+    HeapFree(GetProcessHeap(), 0, This->generic.axis_map);
     return hr;
 }
 
-
 const struct dinput_device joystick_linuxinput_device = {
   "Wine Linux-input joystick driver",
   joydev_enum_deviceA,
